const TblTipoArtigo = require("../models/TblTiposArtigo");

const getAllTiposArtigo = async (queryParams = {}) => {
  return TblTipoArtigo.findAll({
    where: queryParams,
  });
};

const getTipoArtigoById = async (id, queryParams = {}) => {
  const whereCondition = { intId: id, ...queryParams };

  return TblTipoArtigo.findOne({
    where: whereCondition,
  });
};



const createTipoArtigo = async (tipoArtigoData) => {
  return TblTipoArtigo.create(tipoArtigoData);
};

const updateTipoArtigo = async (id, tipoArtigoData) => {
  const tipoArtigo = await TblTipoArtigo.findByPk(id);
  if (!tipoArtigo) {
    throw new Error("TipoArtigo not found");
  }
  return tipoArtigo.update(tipoArtigoData);
};

const deleteTipoArtigo = async (id) => {
  // Assuming TblTipoArtigo is your Sequelize model
  const result = await TblTipoArtigo.update(
    { bitEliminado: true },
    { where: { intId: id } }
  );

  // The 'result' object contains information about the operation
  const affectedRows = result[0];

  if (affectedRows === 0) {
    throw new Error("TipoArtigo not found");
  }

  // You might want to return additional information if needed
  return { success: true, message: "TipoArtigo soft deleted successfully" };
};

module.exports = {
  getAllTiposArtigo,
  getTipoArtigoById,
  createTipoArtigo,
  updateTipoArtigo,
  deleteTipoArtigo,
};
